/* 
* I2C.h
*
* Created: 2014/06/21 14:04:25
* Author: SIMON
*/

#ifndef __I2C_H__
#define __I2C_H__

#include <avr/io.h>

class I2C
{
	
private:
	
	unsigned char Address;
	unsigned char ReadOrWrite;
	unsigned int MaxLoopTime;


public:
	I2C();
	unsigned char CheckIntFlag();
	unsigned char GetStatus();
	void SetTWDRData(unsigned char _Data);
	void ClearIntFlag();
	void CheckAndClearIntFlag();
	unsigned char LoopUntilFlagSet();
	void SetWriteAddress(unsigned char _WriteAddress);
	void SetOwnAddress(unsigned char _OwnAddress, unsigned char EnGeneralCall);
	void SetBR(unsigned char _BR,unsigned char _PS);
	void SetRW(unsigned char _RW);//_RW0Write,1Read
	void WriteToSlave(unsigned char _Data);
	unsigned char ReadFromMaster();
	
	void SetMaxLoopTime(unsigned char val);//Max:65535
	void SetTWSTA(unsigned char val);
	void SetTWSTO(unsigned char val);
	void SetTWEN(unsigned char val);
	void SetTWEA(unsigned char val);

	~I2C();

}; //I2C

#endif //__I2C_H__
